<template>
    <div>
        <h1 class="is-1 has-text-centered has-text-weight-bold">
            {{ map._focused._name }}
        </h1>

        <hr class="navbar-divider">
        
        <div v-if="isFocusedAFolders() || isFocusedAPoint() || ((isFocusedAPath() || isFocusedAFolder()) && ! isFocusedTheOnlyChild())">
            <div class="columns is-mobile is-gapless is-multiline is-vcentered">
                <div class="column is-one-fifth has-text-centered has-text-weight-bold">
                    Icon:
                </div>
                <div v-bind:key="key" v-for="(style, key) in ICONS" class="column is-one-fifth">
                    <a 
                        v-on:click="map._focused.updateIcon(key)"
                        v-bind:class="{ 'is-active' : (map._focused.icon === key) }"
                        class="navbar-item is-block"
                    >
                        <icon-base v-bind:name="key" />
                    </a>
                </div>
            </div>

            <div class="columns is-mobile is-gapless is-vcentered has-xsmall-vpadding">
                <div class="column has-text-centered has-text-weight-bold">
                    Disablers:
                </div>
                <div class="column">
                    <a 
                        v-on:click='map._focused.togglePoints()'
                        v-bind:class="{ 'is-active' : ! map._focused.arePointsVisible }"
                        class='navbar-item is-block'
                    >
                        <icon-base name='CIRCLE_OFF' />
                    </a>
                </div>
                <div class="column">
                    <a 
                        v-on:click='map._focused.togglePointsText()'
                        v-bind:class="{ 'is-active' : ! map._focused.arePointsTextsVisible }"
                        class='navbar-item is-block'
                    >
                        <icon-base name='TEXT_OFF' />
                    </a>
                </div>
                <div v-if="! isFocusedAPoint()" class="column">
                    <a
                        v-on:click='map._focused.toggleLines(map._mapboxMap)'
                        v-bind:class="{ 'is-active' : ! map._focused.areLinesVisible }"
                        class='navbar-item is-block'
                    >
                        <icon-base name='SHARE_OFF' />
                    </a>
                </div>
                <div v-else class="column">
                    <a
                        v-on:click='map._focused._mapboxMarker.setDraggable(! map._focused._mapboxMarker.isDraggable())'
                        v-bind:class="{ 'is-active' : map._focused._mapboxMarker.isDraggable() }"
                        class='navbar-item is-block'
                    >
                        <icon-base name='MOVE' />
                    </a>
                </div>
                <div v-if="isFocusedAFolders()" class="column">
                    <a
                        v-on:click='map.images.toggle(map._mapboxMap)'
                        v-bind:class="{ 'is-active' : ! map.images.areVisible }"
                        class='navbar-item is-block'
                    >
                        <icon-base name='IMAGE_OFF' />
                    </a>
                </div>
            </div>
        </div>

        <div v-if="! isFocusedAFolders()">
            <div v-if="! isFocusedAPath() || (isFocusedAPath() && ! isFocusedTheOnlyChild())">
                <div v-if="isFocusedAFolder() || isFocusedAPath()" >
                    <custom-input v-bind:linked-input="this.map._focused.equation" v-bind:function="inputEquation" />
                    
                    <div class="columns is-mobile is-gapless is-vcentered">
                        <div class="column is-2">
                            <div class="has-text-weight-bold">Limits:</div>
                        </div>
                        <div class="column">
                            <limit v-bind:limit='map._focused.limitLow' />
                            <limit v-bind:limit='map._focused.limitHigh' />
                        </div>
                    </div>
                </div>

                <hr class="navbar-divider">
            </div>

            <div v-bind:key="key" v-for="(value, key) in Object.keys(map._focused.information)">
                <custom-input v-bind:linked-input="map._focused.information[value]" />
            </div>

            <div v-if="isFocusedAPoint()">
                <hr class="navbar-divider">

                <div v-bind:key="key" v-for="(value, key) in Object.keys(map._focused.values)">
                    <div v-if="value !== 'kind'" class="field is-horizontal has-xsmall-vpadding">
                        <div class="field-label is-normal">
                            <label class="label">{{ value }}:</label>
                        </div>
                        <div class="field-body">
                            <div class="field">
                                <p class="control">
                                    <input class="input is-rounded is-hovered" v-bind:value="map._focused.values[value]" readonly />
                                </p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue } from 'vue-property-decorator';
    import { State } from 'vuex-class';
    import CustomInput from './CustomInput.vue';
    import IconBase from './IconBase.vue';
    import Limit from './Limit.vue';

    import { MARKER_ICONS } from '@/ts/enums';
    import { Folder } from '@/ts/folder';
    import { Folders } from '@/ts/folders';
    import { Mapview } from '@/ts/mapview';
    import { Path } from '@/ts/path';
    import { Point } from '@/ts/point';

    @Component({
        components: {
            CustomInput,
            IconBase,
            Limit,
        },
    })
    export default class Focused extends Vue {
        @State('map') private map!: Mapview;

        private ICONS: typeof MARKER_ICONS = MARKER_ICONS;

        private inputEquation(): void {
            if (this.map._mapboxMap !== undefined && (this.map._focused instanceof Folder || this.map._focused instanceof Path)) {
                this.map._focused.updateColors(this.map._mapboxMap);
            }
        }

        private isFocusedAFolder(): boolean {
            return (this.map._focused instanceof Folder);
        }

        private isFocusedAFolders(): boolean {
            return (this.map._focused instanceof Folders);
        }

        private isFocusedAPath(): boolean {
            return (this.map._focused instanceof Path);
        }

        private isFocusedAPoint(): boolean {
            return (this.map._focused instanceof Point);
        }

        private isFocusedTheOnlyChild(): boolean {
            let bool: boolean = false;
            if (this.map._focused instanceof Folder) {
                bool = this.map.folders.folders.length === 1;
            } else {
                this.map.folders.folders.forEach((folder: Folder) => {
                    if (this.map._focused instanceof Path && folder.paths.includes(this.map._focused)) {
                        bool = folder.paths.length === 1;
                    }
                });
            }
            return bool;
        }
    }
</script>